using System;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Imaging;

namespace TestProject
{
    /// <summary>
    /// Ʈ Ʈ
    /// </summary>
    public class BitmapElement : UIElement
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Event
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Ʈ н - BitmapFailed

        /// <summary>
        /// Ʈ н
        /// </summary>
        public event EventHandler<ExceptionEventArgs> BitmapFailed;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Dependency Property
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region ҽ Ӽ - SourceProperty

        /// <summary>
        /// ҽ Ӽ
        /// </summary>
        public static readonly DependencyProperty SourceProperty = DependencyProperty.Register
        (
            "Source",
            typeof(BitmapSource),
            typeof(BitmapElement),
            new FrameworkPropertyMetadata
            (
                null,
                FrameworkPropertyMetadataOptions.AffectsRender | FrameworkPropertyMetadataOptions.AffectsMeasure,
                new PropertyChangedCallback(SourcePropertyChangedCallback)
            )
        );

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// Ʈ ҽ ٿε Ϸ ̺Ʈ ڵ鷯
        /// </summary>
        private EventHandler bitmapSourceDownloadCompletedEventHandler;

        /// <summary>
        /// Ʈ ҽ ٿε н ̺Ʈ ڵ鷯
        /// </summary>
        private EventHandler<ExceptionEventArgs> bitmapSourceDownloadFailedEventHandler;
        
        /// <summary>
        /// ȼ 
        /// </summary>
        private Point pixelOffset;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ҽ - Source

        /// <summary>
        /// ҽ
        /// </summary>
        public BitmapSource Source
        {
            get
            {
                return (BitmapSource)GetValue(SourceProperty);
            }
            set
            {
                SetValue(SourceProperty, value);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - BitmapElement()

        /// <summary>
        /// 
        /// </summary>
        public BitmapElement()
        {
            this.bitmapSourceDownloadCompletedEventHandler = new EventHandler(bitmapSource_DownloadCompleted);
            this.bitmapSourceDownloadFailedEventHandler    = new EventHandler<ExceptionEventArgs>(bitmapSource_DownloadFailed);

            LayoutUpdated += UIElement_LayoutUpdated;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region ҽ Ӽ  ݹ óϱ - SourcePropertyChangedCallback(d, e)

        /// <summary>
        /// ҽ Ӽ  ݹ óϱ
        /// </summary>
        /// <param name="d"> ü</param>
        /// <param name="e">̺Ʈ </param>
        private static void SourcePropertyChangedCallback(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            BitmapElement bitmapElement = (BitmapElement)d;

            BitmapSource oldSource = (BitmapSource)e.OldValue;
            BitmapSource newSource = (BitmapSource)e.NewValue;

            if((oldSource != null) && (bitmapElement.bitmapSourceDownloadCompletedEventHandler != null) && !oldSource.IsFrozen && (oldSource is BitmapSource))
            {
                oldSource.DownloadCompleted -= bitmapElement.bitmapSourceDownloadCompletedEventHandler;
                oldSource.DownloadFailed    -= bitmapElement.bitmapSourceDownloadFailedEventHandler;
            }

            if((newSource != null) && (newSource is BitmapSource) && !newSource.IsFrozen)
            {
                newSource.DownloadCompleted += bitmapElement.bitmapSourceDownloadCompletedEventHandler;
                newSource.DownloadFailed    += bitmapElement.bitmapSourceDownloadFailedEventHandler;
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Protected

        #region ϱ (ھ) - MeasureCore(availableSize)

        /// <summary>
        /// ϱ (ھ)
        /// </summary>
        /// <param name="availableSize">̿  ũ</param>
        /// <returns> ũ</returns>
        protected override Size MeasureCore(Size availableSize)
        {
            Size measureSize = new Size();

            BitmapSource bitmapSource = Source;

            if(bitmapSource != null)
            {
                PresentationSource presentationSource = PresentationSource.FromVisual(this);

                if(presentationSource != null)
                {
                    Matrix fromDeviceMartix  = presentationSource.CompositionTarget.TransformFromDevice;
                    Vector pixelSizeVector   = new Vector(bitmapSource.PixelWidth, bitmapSource.PixelHeight);
                    Vector measureSizeVector = fromDeviceMartix.Transform(pixelSizeVector);

                    measureSize = new Size(measureSizeVector.X, measureSizeVector.Y);
                }
            }

            return measureSize;
        }

        #endregion
        #region  óϱ - OnRender(context)

        /// <summary>
        ///  óϱ
        /// </summary>
        /// <param name="context"> ؽƮ</param>
        protected override void OnRender(DrawingContext context)
        {
            this.pixelOffset = GetPixelOffset();

            BitmapSource bitmapSource = Source;

            if(bitmapSource != null)
            {
                context.DrawImage(bitmapSource, new Rect(this.pixelOffset, DesiredSize));
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private
        ////////////////////////////////////////////////////////////////////// Event

        #region UI Ʈ ̾ƿ Ʈ óϱ - UIElement_LayoutUpdated(sender, e)

        /// <summary>
        /// UI Ʈ ̾ƿ Ʈ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void UIElement_LayoutUpdated(object sender, EventArgs e)
        {
            Point pixelOffset = GetPixelOffset();

            if(!IsAreClosed(pixelOffset, this.pixelOffset))
            {
                InvalidateVisual();
            }
        }

        #endregion
        #region Ʈ ҽ ٿε Ϸ óϱ - bitmapSource_DownloadCompleted(sender, e)

        /// <summary>
        /// Ʈ ҽ ٿε Ϸ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void bitmapSource_DownloadCompleted(object sender, EventArgs e)
        {
            InvalidateMeasure();

            InvalidateVisual();
        }

        #endregion
        #region Ʈ ҽ ٿε н óϱ - bitmapSource_DownloadFailed(sender, e)

        /// <summary>
        /// Ʈ ҽ ٿε н óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void bitmapSource_DownloadFailed(object sender, ExceptionEventArgs e)
        {
            Source = null;

            BitmapFailed(this, e);
        }

        #endregion

        ////////////////////////////////////////////////////////////////////// Function

        #region ־ ȯ Ʈ ϱ - GetVisualTransformMatrix(visual)

        /// <summary>
        /// ־ ȯ Ʈ ϱ
        /// </summary>
        /// <param name="visual">־</param>
        /// <returns>־ ȯ Ʈ</returns>
        private Matrix GetVisualTransformMatrix(Visual visual)
        {
            if(visual != null)
            {
                Matrix matrix = Matrix.Identity;

                Transform transform = VisualTreeHelper.GetTransform(visual);

                if(transform != null)
                {
                    Matrix transformMatrix = transform.Value;

                    matrix = Matrix.Multiply(matrix, transformMatrix);
                }

                Vector offsetVector = VisualTreeHelper.GetOffset(visual);

                matrix.Translate(offsetVector.X, offsetVector.Y);

                return matrix;
            }

            return Matrix.Identity;
        }

        #endregion
        #region ־ ȯ ϱ - ApplyVisualTransform(point, visual, inverse, throwException, success)

        /// <summary>
        /// ־ ȯ ϱ
        /// </summary>
        /// <param name="point">Ʈ</param>
        /// <param name="visual">־</param>
        /// <param name="inverse"> </param>
        /// <param name="throwException"> ߻ </param>
        /// <param name="success"> </param>
        /// <returns>־ ȯ Ʈ</returns>
        private Point ApplyVisualTransform(Point point, Visual visual, bool inverse, bool throwException, out bool success)
        {
            success = true;

            if(visual != null)
            {
                Matrix matrix = GetVisualTransformMatrix(visual);

                if(inverse)
                {
                    if(!throwException && !matrix.HasInverse)
                    {
                        success = false;

                        return new Point(0, 0);
                    }

                    matrix.Invert();
                }

                point = matrix.Transform(point);
            }

            return point;
        }

        #endregion
        #region ־ ȯ ϱ - ApplyVisualTransform(point, visual, inverse)

        /// <summary>
        /// ־ ȯ ϱ
        /// </summary>
        /// <param name="point">Ʈ</param>
        /// <param name="visual">־</param>
        /// <param name="inverse"> </param>
        /// <returns>־ ȯ Ʈ</returns>
        private Point ApplyVisualTransform(Point point, Visual visual, bool inverse)
        {
            return ApplyVisualTransform(point, visual, inverse, true, out _);
        }

        #endregion
        #region ȼ  ϱ - GetPixelOffset()

        /// <summary>
        /// ȼ  ϱ
        /// </summary>
        /// <returns>ȼ </returns>
        private Point GetPixelOffset()
        {
            Point pixelOffset = new Point();

            PresentationSource presentationSource = PresentationSource.FromVisual(this);

            if(presentationSource != null)
            {
                Visual rootVisual = presentationSource.RootVisual;

                pixelOffset = TransformToAncestor(rootVisual).Transform(pixelOffset);
                pixelOffset = ApplyVisualTransform(pixelOffset, rootVisual, false);
                pixelOffset = presentationSource.CompositionTarget.TransformToDevice.Transform(pixelOffset);

                pixelOffset.X = Math.Round(pixelOffset.X);
                pixelOffset.Y = Math.Round(pixelOffset.Y);

                pixelOffset = presentationSource.CompositionTarget.TransformFromDevice.Transform(pixelOffset);
                pixelOffset = ApplyVisualTransform(pixelOffset, rootVisual, true);
                pixelOffset = rootVisual.TransformToDescendant(this).Transform(pixelOffset);
            }

            return pixelOffset;
        }

        #endregion
        #region ȣ   ϱ - IsAreClosed(value1, value2)

        /// <summary>
        /// ȣ   ϱ
        /// </summary>
        /// <param name="value1"> 1</param>
        /// <param name="value2"> 2</param>
        /// <returns>ȣ  </returns>
        private bool IsAreClosed(double value1, double value2)
        {
            if(value1 == value2)
            {
                return true;
            }

            double delta = value1 - value2;

            return (delta < 1.53E-06) && (delta > -1.53E-06);
        }

        #endregion
        #region ȣ   ϱ - IsAreClosed(point1, point2)

        /// <summary>
        /// ȣ   ϱ
        /// </summary>
        /// <param name="point1">Ʈ 1</param>
        /// <param name="point2">Ʈ 2</param>
        /// <returns>ȣ  </returns>
        private bool IsAreClosed(Point point1, Point point2)
        {
            return IsAreClosed(point1.X, point2.X) && IsAreClosed(point1.Y, point2.Y);
        }

        #endregion
    }
}