using System;
using System.ComponentModel;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Media;

namespace TestProject
{
    /// <summary>
    /// GDI ؽƮ 
    /// </summary>
    public class GDITextBlock : FrameworkElement
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Dependency Property
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region ؽƮ Ӽ - TextProperty

        /// <summary>
        /// ؽƮ Ӽ
        /// </summary>
        public static readonly DependencyProperty TextProperty = TextBlock.TextProperty.AddOwner
        (
            typeof(GDITextBlock),
            new FrameworkPropertyMetadata { AffectsMeasure = true }
        );

        #endregion
        #region ؽƮ ǰ Ӽ - TextQualityProperty

        /// <summary>
        /// ؽƮ ǰ Ӽ
        /// </summary>
        public static readonly DependencyProperty TextQualityProperty = DependencyProperty.Register
        (
            "TextQuality",
            typeof(GDITextQuality),
            typeof(GDITextBlock),
            new FrameworkPropertyMetadata
            {
                DefaultValue        = GDITextQuality.SingleBitPerPixelGridFit,
                AffectsMeasure      = true,
                CoerceValueCallback = TextQualityProperty_CoerceValueCallback
            }
        );

        #endregion
        #region ؽƮ  Ӽ - TextAlignmentProperty

        /// <summary>
        /// ؽƮ  Ӽ
        /// </summary>
        public static readonly DependencyProperty TextAlignmentProperty = Block.TextAlignmentProperty.AddOwner
        (
            typeof(GDITextBlock),
            new FrameworkPropertyMetadata
            {
                AffectsMeasure      = true,
                CoerceValueCallback = TextAlignmentProperty_CoerceValueCallback
            }
        );

        #endregion
        #region ؽƮ  Ӽ - TextWrappingProperty

        /// <summary>
        /// ؽƮ  Ӽ
        /// </summary>
        public static readonly DependencyProperty TextWrappingProperty = TextBlock.TextWrappingProperty.AddOwner
        (
            typeof(GDITextBlock),
            new FrameworkPropertyMetadata
            {
                AffectsMeasure      = true,
                CoerceValueCallback = TextWrappingProperty_CoerceValueCallback
            }
        );

        #endregion
        #region ؽƮ Ʈ Ӽ - TextTrimmingProperty

        /// <summary>
        /// ؽƮ Ʈ Ӽ
        /// </summary>
        public static readonly DependencyProperty TextTrimmingProperty = TextBlock.TextTrimmingProperty.AddOwner
        (
            typeof(GDITextBlock),
            new FrameworkPropertyMetadata { AffectsMeasure = true }
        );

        #endregion
        #region Ʈ йи Ӽ - FontFamilyProperty

        /// <summary>
        /// Ʈ йи Ӽ
        /// </summary>
        public static readonly DependencyProperty FontFamilyProperty = TextElement.FontFamilyProperty.AddOwner
        (
            typeof(GDITextBlock),
            new FrameworkPropertyMetadata { AffectsMeasure = true }
        );

        #endregion
        #region Ʈ Ÿ Ӽ - FontStyleProperty

        /// <summary>
        /// Ʈ Ÿ Ӽ
        /// </summary>
        public static readonly DependencyProperty FontStyleProperty = TextElement.FontStyleProperty.AddOwner
        (
            typeof(GDITextBlock),
            new FrameworkPropertyMetadata
            {
                AffectsMeasure      = true,
                CoerceValueCallback = FontStyleProperty_CoerceValueCallback
            }
        );

        #endregion
        #region Ʈ ġ Ӽ - FontWeightProperty

        /// <summary>
        /// Ʈ ġ Ӽ
        /// </summary>
        public static readonly DependencyProperty FontWeightProperty = TextElement.FontWeightProperty.AddOwner
        (
            typeof(GDITextBlock),
            new FrameworkPropertyMetadata
            {
                AffectsMeasure      = true,
                CoerceValueCallback = FontWeightProperty_CoerceValueCallback
            }
        );

        #endregion
        #region Ʈ ũ Ӽ - FontSizeProperty

        /// <summary>
        /// Ʈ ũ Ӽ
        /// </summary>
        public static readonly DependencyProperty FontSizeProperty = TextElement.FontSizeProperty.AddOwner
        (
            typeof(GDITextBlock),
            new FrameworkPropertyMetadata { AffectsMeasure = true }
        );

        #endregion
        #region  Ӽ - ForegroundProperty

        /// <summary>
        ///  Ӽ
        /// </summary>
        public static readonly DependencyProperty ForegroundProperty = TextElement.ForegroundProperty.AddOwner
        (
            typeof(GDITextBlock),
            new FrameworkPropertyMetadata
            {
                AffectsMeasure      = true,
                CoerceValueCallback = ForegroundProperty_CoerceValueCallback
            }
        );

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// Ʈ Ʈ
        /// </summary>
        private BitmapElement bitmapElement;

        /// <summary>
        /// ׸ 귯
        /// </summary>
        private System.Drawing.Brush drawingBrush;

        /// <summary>
        /// ׸ Ʈ
        /// </summary>
        private System.Drawing.Font drawingFont;

        /// <summary>
        /// ׸ ڿ 
        /// </summary>
        private System.Drawing.StringFormat drawingStringFormat;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ؽƮ - Text

        /// <summary>
        /// ؽƮ
        /// </summary>
        public string Text
        {
            get
            {
                return (string)GetValue(TextProperty);
            }
            set
            {
                SetValue(TextProperty, value);
            }
        }

        #endregion
        #region ؽƮ ǰ - TextQuality

        /// <summary>
        /// ؽƮ ǰ
        /// </summary>
        public GDITextQuality TextQuality
        {
            get
            {
                return (GDITextQuality)GetValue(TextQualityProperty);
            }
            set
            {
                SetValue(TextQualityProperty, value);
            }
        }

        #endregion
        #region ؽƮ  - TextAlignment

        /// <summary>
        /// ؽƮ 
        /// </summary>
        public TextAlignment TextAlignment
        {
            get
            {
                return (TextAlignment)GetValue(TextAlignmentProperty);
            }
            set
            {
                SetValue(TextAlignmentProperty, value);
            }
        }

        #endregion
        #region ؽƮ  - TextWrapping

        /// <summary>
        /// ؽƮ 
        /// </summary>
        public TextWrapping TextWrapping
        {
            get
            {
                return (TextWrapping)GetValue(TextWrappingProperty);
            }
            set
            {
                SetValue(TextWrappingProperty, value);
            }
        }

        #endregion
        #region ؽƮ Ʈ - TextTrimming

        /// <summary>
        /// ؽƮ Ʈ
        /// </summary>
        public TextTrimming TextTrimming
        {
            get
            {
                return (TextTrimming)GetValue(TextTrimmingProperty);
            }
            set
            {
                SetValue(TextTrimmingProperty, value);
            }
        }

        #endregion
        #region Ʈ йи - FontFamily

        /// <summary>
        /// Ʈ йи
        /// </summary>
        public FontFamily FontFamily
        {
            get
            {
                return (FontFamily)GetValue(FontFamilyProperty);
            }
            set
            {
                SetValue(FontFamilyProperty, value);
            }
        }

        #endregion
        #region Ʈ Ÿ - FontStyle

        /// <summary>
        /// Ʈ Ÿ
        /// </summary>
        public FontStyle FontStyle
        {
            get
            {
                return (FontStyle)GetValue(FontStyleProperty);
            }
            set
            {
                SetValue(FontStyleProperty, value);
            }
        }

        #endregion
        #region Ʈ ġ - FontWeight

        /// <summary>
        /// Ʈ ġ
        /// </summary>
        public FontWeight FontWeight
        {
            get
            {
                return (FontWeight)GetValue(FontWeightProperty);
            }
            set
            {
                SetValue(FontWeightProperty, value);
            }
        }

        #endregion
        #region Ʈ ũ - FontSize

        /// <summary>
        /// Ʈ ũ
        /// </summary>
        [TypeConverter(typeof(FontSizeConverter))]
        public double FontSize
        {
            get
            {
                return (double)GetValue(FontSizeProperty);
            }
            set
            {
                SetValue(FontSizeProperty, value);
            }
        }

        #endregion
        #region  - Foreground

        /// <summary>
        /// 
        /// </summary>
        public SolidColorBrush Foreground
        {
            get
            {
                return (SolidColorBrush)GetValue(ForegroundProperty);
            }
            set
            {
                SetValue(ForegroundProperty, value);
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Proptected

        #region ־ ڽ  - VisualChildrenCount

        /// <summary>
        /// ־ ڽ 
        /// </summary>
        protected override int VisualChildrenCount
        {
            get
            {
                return 1;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region ؽƮ ǰ Ӽ   ݹ óϱ - TextQualityProperty_CoerceValueCallback(d, baseValue)

        /// <summary>
        /// ؽƮ ǰ Ӽ   ݹ óϱ
        /// </summary>
        /// <param name="d"> ü</param>
        /// <param name="baseValue">⺻ </param>
        /// <returns>ó </returns>
        private static object TextQualityProperty_CoerceValueCallback(DependencyObject d, object baseValue)
        {
            if(!Enum.IsDefined(typeof(GDITextQuality), baseValue))
            {
                baseValue = TextQualityProperty.DefaultMetadata.DefaultValue;
            }

            return baseValue;
        }

        #endregion
        #region ؽƮ  Ӽ   ݹ óϱ - TextAlignmentProperty_CoerceValueCallback(d, baseValue)

        /// <summary>
        /// ؽƮ  Ӽ   ݹ óϱ
        /// </summary>
        /// <param name="d"> ü</param>
        /// <param name="baseValue">⺻ </param>
        /// <returns>ó </returns>
        private static object TextAlignmentProperty_CoerceValueCallback(DependencyObject d, object baseValue)
        {
            if(baseValue.Equals(TextAlignment.Justify))
            {
                baseValue = TextAlignmentProperty.DefaultMetadata.DefaultValue;
            }

            return baseValue;
        }

        #endregion
        #region ؽƮ  Ӽ   ݹ óϱ - TextWrappingProperty_CoerceValueCallback(d, baseValue)

        /// <summary>
        /// ؽƮ  Ӽ   ݹ óϱ
        /// </summary>
        /// <param name="d"> ü</param>
        /// <param name="baseValue">⺻ </param>
        /// <returns>ó </returns>
        private static object TextWrappingProperty_CoerceValueCallback(DependencyObject d, object baseValue)
        {
            if(baseValue.Equals(TextWrapping.WrapWithOverflow))
            {
                baseValue = TextWrapping.Wrap;
            }

            return baseValue;
        }

        #endregion
        #region Ʈ Ÿ Ӽ   ݹ óϱ - FontStyleProperty_CoerceValueCallback(d, baseValue)

        /// <summary>
        /// Ʈ Ÿ Ӽ   ݹ óϱ
        /// </summary>
        /// <param name="d"> ü</param>
        /// <param name="baseValue">⺻ </param>
        /// <returns>ó </returns>
        private static object FontStyleProperty_CoerceValueCallback(DependencyObject d, object baseValue)
        {
            if(baseValue.Equals(FontStyles.Oblique))
            {
                baseValue = TextAlignmentProperty.DefaultMetadata.DefaultValue;
            }

            return baseValue;
        }

        #endregion
        #region Ʈ ġ Ӽ   ݹ óϱ - FontWeightProperty_CoerceValueCallback(d, baseValue)

        /// <summary>
        /// Ʈ ġ Ӽ   ݹ óϱ
        /// </summary>
        /// <param name="d"> ü</param>
        /// <param name="baseValue">⺻ </param>
        /// <returns>ó </returns>
        private static object FontWeightProperty_CoerceValueCallback(DependencyObject d, object baseValue)
        {
            if(!baseValue.Equals(FontWeights.Bold) && !baseValue.Equals(FontWeights.Regular) && !baseValue.Equals(FontWeights.Normal))
            {
                baseValue = TextAlignmentProperty.DefaultMetadata.DefaultValue;
            }

            return baseValue;
        }

        #endregion
        #region  Ӽ   ݹ óϱ - ForegroundProperty_CoerceValueCallback(d, baseValue)

        /// <summary>
        ///  Ӽ   ݹ óϱ
        /// </summary>
        /// <param name="d"> ü</param>
        /// <param name="baseValue">⺻ </param>
        /// <returns>ó </returns>
        private static object ForegroundProperty_CoerceValueCallback(DependencyObject d, object baseValue)
        {
            if(!(baseValue is SolidColorBrush))
            {
                baseValue = ForegroundProperty.DefaultMetadata.DefaultValue;
            }

            return baseValue;
        }

        #endregion

        #region Ʈ ҽ ϱ - GetBitmapSource(bitmap)

        /// <summary>
        /// Ʈ ҽ ϱ
        /// </summary>
        /// <param name="bitmap">Ʈ</param>
        /// <returns>Ʈ ҽ</returns>
        private static System.Windows.Media.Imaging.BitmapSource GetBitmapSource(System.Drawing.Bitmap bitmap)
        {
            System.Drawing.Rectangle rectangle = new System.Drawing.Rectangle(0, 0, bitmap.Width, bitmap.Height);

            System.Drawing.Imaging.BitmapData bitmapData = bitmap.LockBits
            (
                rectangle,
                System.Drawing.Imaging.ImageLockMode.ReadOnly,
                bitmap.PixelFormat
            );

            System.Windows.Media.Imaging.BitmapSource bitmapSource = System.Windows.Media.Imaging.BitmapSource.Create
            (
                bitmap.Width,
                bitmap.Height,
                bitmap.HorizontalResolution,
                bitmap.VerticalResolution,
                PixelFormats.Pbgra32,
                null,
                bitmapData.Scan0,
                bitmapData.Stride * bitmap.Height,
                bitmapData.Stride
            );

            bitmap.UnlockBits(bitmapData);

            return bitmapSource;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Protected

        #region ʱȭ óϱ - OnInitialized(e)

        /// <summary>
        /// ʱȭ óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnInitialized(EventArgs e)
        {
            this.bitmapElement = new BitmapElement();

            AddVisualChild(this.bitmapElement);

            base.OnInitialized(e);
        }

        #endregion
        #region ־ ڽ ϱ - GetVisualChild(index)

        /// <summary>
        /// ־ ڽ ϱ
        /// </summary>
        /// <param name="index"></param>
        /// <returns>־ ڽ</returns>
        protected override Visual GetVisualChild(int index)
        {
            return this.bitmapElement;
        }

        #endregion
        #region ϱ (̵) - MeasureOverride(availableSize)

        /// <summary>
        /// ϱ (̵)
        /// </summary>
        /// <param name="availableSize">̿  ũ</param>
        /// <returns> ũ</returns>
        protected override Size MeasureOverride(Size availableSize)
        {
            Matrix dpiMatrix = PresentationSource.FromVisual(this).CompositionTarget.TransformToDevice;

            float dpiX = (float)dpiMatrix.M11;
            float dpiY = (float)dpiMatrix.M22;

            CreateDrawingObjects(dpiX);

            System.Drawing.Size size = new System.Drawing.Size();

            using(System.Drawing.Bitmap bitmap = new System.Drawing.Bitmap(1, 1))
            {
                using(System.Drawing.Graphics graphics = System.Drawing.Graphics.FromImage(bitmap))
                {
                    graphics.TextRenderingHint = (System.Drawing.Text.TextRenderingHint)TextQuality;

                    System.Drawing.SizeF boundarySize = new System.Drawing.SizeF
                    (
                        (float)availableSize.Width  * dpiX,
                        (float)availableSize.Height * dpiY
                    );

                    boundarySize = graphics.MeasureString(Text, this.drawingFont, boundarySize, this.drawingStringFormat);

                    size = new System.Drawing.Size
                    (
                        (int)Math.Ceiling(boundarySize.Width ),
                        (int)Math.Ceiling(boundarySize.Height)
                    );
                }
            }

            using(System.Drawing.Bitmap bitmap = new System.Drawing.Bitmap(size.Width, size.Height))
            {
                using(System.Drawing.Graphics graphics = System.Drawing.Graphics.FromImage(bitmap))
                {
                    graphics.TextRenderingHint = (System.Drawing.Text.TextRenderingHint)TextQuality;

                    Color color = Foreground.Color;

                    graphics.DrawString
                    (
                        Text,
                        this.drawingFont,
                        this.drawingBrush,
                        new System.Drawing.RectangleF(0, 0, size.Width, size.Height),
                        this.drawingStringFormat
                    );

                    this.bitmapElement.Source = GetBitmapSource(bitmap);

                    this.bitmapElement.InvalidateMeasure();

                    this.bitmapElement.InvalidateVisual();
                }
            }

            this.bitmapElement.Measure(availableSize);

            return this.bitmapElement.DesiredSize;
        }

        #endregion
        #region 迭ϱ (̵) - ArrangeOverride(finalSize)

        /// <summary>
        /// 迭ϱ (̵)
        /// </summary>
        /// <param name="finalSize"> ũ</param>
        /// <returns>迭 ũ</returns>
        protected override Size ArrangeOverride(Size finalSize)
        {
            this.bitmapElement.Arrange(new Rect(finalSize));

            return finalSize;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region ׸ ü ҽ ϱ - DisposeDrawingObjects()

        /// <summary>
        /// ׸ ü ҽ ϱ
        /// </summary>
        private void DisposeDrawingObjects()
        {
            if(this.drawingBrush != null)
            {
                this.drawingBrush.Dispose();
            }

            if(this.drawingFont != null)
            {
                this.drawingFont.Dispose();
            }

            if(this.drawingStringFormat != null)
            {
                this.drawingStringFormat.Dispose();
            }
        }

        #endregion
        #region ׸ ü ϱ - CreateDrawingObjects(dpi)

        /// <summary>
        /// ׸ ü ϱ
        /// </summary>
        /// <param name="dpi">DPI</param>
        private void CreateDrawingObjects(float dpi)
        {
            DisposeDrawingObjects();

            Color color = Foreground.Color;

            this.drawingBrush = new System.Drawing.SolidBrush
            (
                System.Drawing.Color.FromArgb
                (
                    (int)color.A,
                    (int)color.R,
                    (int)color.G,
                    (int)color.B
                )
            );

            System.Drawing.FontStyle style = System.Drawing.FontStyle.Regular;

            if(FontWeight == FontWeights.Bold)
            {
                style |= System.Drawing.FontStyle.Bold;
            }

            if(FontStyle == FontStyles.Italic)
            {
                style |= System.Drawing.FontStyle.Italic;
            }

            this.drawingFont = new System.Drawing.Font
            (
                FontFamily.Source,
                (float)(FontSize * dpi),
                style,
                System.Drawing.GraphicsUnit.Pixel
            );

            this.drawingStringFormat = new System.Drawing.StringFormat();

            switch(TextTrimming)
            {
                case TextTrimming.None :

                    this.drawingStringFormat.Trimming = System.Drawing.StringTrimming.None;

                    break;

                case TextTrimming.CharacterEllipsis :

                    this.drawingStringFormat.Trimming = System.Drawing.StringTrimming.EllipsisCharacter;

                    break;

                case TextTrimming.WordEllipsis :

                    this.drawingStringFormat.Trimming = System.Drawing.StringTrimming.EllipsisWord;

                    break;
            }

            this.drawingStringFormat.FormatFlags = System.Drawing.StringFormatFlags.LineLimit;

            if(TextWrapping == TextWrapping.NoWrap)
            {
                this.drawingStringFormat.FormatFlags |= System.Drawing.StringFormatFlags.NoWrap;
            }

            if(FlowDirection == FlowDirection.RightToLeft)
            {
                this.drawingStringFormat.FormatFlags |= System.Drawing.StringFormatFlags.DirectionRightToLeft;
            }

            switch(TextAlignment)
            {
                case TextAlignment.Left :

                    this.drawingStringFormat.Alignment = System.Drawing.StringAlignment.Near;

                    break;

                case TextAlignment.Center :

                    this.drawingStringFormat.Alignment = System.Drawing.StringAlignment.Center;

                    break;

                case TextAlignment.Right :

                    this.drawingStringFormat.Alignment = System.Drawing.StringAlignment.Far;

                    break;
            }
        }

        #endregion
    }
}