﻿using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            KeyValuePair<string, SolidColorBrush>[] brushKeyValuePairArray = typeof(Brushes).GetProperties()
                .Where(pi => pi.PropertyType == typeof(SolidColorBrush))
                .Select(pi => new KeyValuePair<string, SolidColorBrush>(pi.Name, (SolidColorBrush)pi.GetValue(null, null)))
                .ToArray();

            this.backgroundColorComboBox.ItemsSource  = brushKeyValuePairArray;
            this.backgroundColorComboBox.SelectedItem = brushKeyValuePairArray.First(c => c.Key == "Transparent");

            this.foregroundColorComboBox.ItemsSource  = brushKeyValuePairArray;
            this.foregroundColorComboBox.SelectedItem = brushKeyValuePairArray.First(c => c.Key == "Black");
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 스크롤 뷰어 스크롤 변경시 처리하기 - ScrollViewer_ScrollChanged(sender, e)

        /// <summary>
        /// 스크롤 뷰어 스크롤 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void ScrollViewer_ScrollChanged(object sender, ScrollChangedEventArgs e)
        {
            ScrollViewer scrollViewer = (sender == this.wpfScrollViewer) ? this.gdiScrollViewer : this.wpfScrollViewer;

            scrollViewer.ScrollToVerticalOffset(e.VerticalOffset);
        }

        #endregion
    }
}